=begin
#TransferZero API

#Reference documentation for the TransferZero API V1

OpenAPI spec version: 1.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.0.0-beta3

=end

require 'uri'

module TransferZero
  class AccountValidationApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end


    # Validates the existence of a bank account or a mobile phone number
    # Validates the existence of a bank account or mobile phone number and returns the associated customer name
    # @param account_validation_request 
    # @param [Hash] opts the optional parameters
    # @return [AccountValidationResponse]
    def post_account_validations(account_validation_request, opts = {})
      data, _status_code, _headers = post_account_validations_with_http_info(account_validation_request, opts)
      data
    end

    # Validates the existence of a bank account or a mobile phone number
    # Validates the existence of a bank account or mobile phone number and returns the associated customer name
    # @param account_validation_request 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AccountValidationResponse, Fixnum, Hash)>] AccountValidationResponse data, response status code and response headers
    def post_account_validations_with_http_info(account_validation_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AccountValidationApi.post_account_validations ...'
      end
      # verify the required parameter 'account_validation_request' is set
      if @api_client.config.client_side_validation && account_validation_request.nil?
        fail ArgumentError, "Missing the required parameter 'account_validation_request' when calling AccountValidationApi.post_account_validations"
      end
      # resource path
      local_var_path = '/account_validations'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(account_validation_request)
      auth_names = ['AuthorizationKey', 'AuthorizationNonce', 'AuthorizationSecret', 'AuthorizationSignature']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AccountValidationResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AccountValidationApi#post_account_validations\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
