=begin
#TransferZero API

#Reference documentation for the TransferZero API V1

OpenAPI spec version: 1.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.0.0-beta3

=end

require 'uri'

module TransferZero
  class PaymentMethodsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end


    # This method returns possible payin methods.
    # Fetching possible payin methods. 
    # @param [Hash] opts the optional parameters
    # @return [PaymentMethodListResponse]
    def payment_methods_in(opts = {})
      data, _status_code, _headers = payment_methods_in_with_http_info(opts)
      data
    end

    # This method returns possible payin methods.
    # Fetching possible payin methods. 
    # @param [Hash] opts the optional parameters
    # @return [Array<(PaymentMethodListResponse, Fixnum, Hash)>] PaymentMethodListResponse data, response status code and response headers
    def payment_methods_in_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PaymentMethodsApi.payment_methods_in ...'
      end
      # resource path
      local_var_path = '/info/payment_methods/in'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['AuthorizationKey', 'AuthorizationNonce', 'AuthorizationSecret', 'AuthorizationSignature']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PaymentMethodListResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PaymentMethodsApi#payment_methods_in\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end


    # This method returns possible payout methods.
    # Fetching possible payout methods. 
    # @param [Hash] opts the optional parameters
    # @return [PaymentMethodListResponse]
    def payment_methods_out(opts = {})
      data, _status_code, _headers = payment_methods_out_with_http_info(opts)
      data
    end

    # This method returns possible payout methods.
    # Fetching possible payout methods. 
    # @param [Hash] opts the optional parameters
    # @return [Array<(PaymentMethodListResponse, Fixnum, Hash)>] PaymentMethodListResponse data, response status code and response headers
    def payment_methods_out_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PaymentMethodsApi.payment_methods_out ...'
      end
      # resource path
      local_var_path = '/info/payment_methods/out'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['AuthorizationKey', 'AuthorizationNonce', 'AuthorizationSecret', 'AuthorizationSignature']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PaymentMethodListResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PaymentMethodsApi#payment_methods_out\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
