=begin
#TransferZero API

#Reference documentation for the TransferZero API V1

OpenAPI spec version: 1.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.0.0-beta3

=end

require 'date'

module TransferZero
# ```JSON \"details\": {   \"first_name\": \"First\",   \"last_name\": \"Last\",   \"phone_number\": \"212537718685\"     # Mandatory; International format preferred   \"sender_identity_card_type\" => \"O\",     # Mandatory; Values: \"O\": Other, \"PP\": Passport, \"ID\": National ID   \"sender_identity_card_id\" => 'AB12345678',     # Mandatory   \"sender_city_of_birth\" => \"London\",     # Optional   \"sender_country_of_birth\" => \"GB\",     # Optional; ISO 2-letter format   \"sender_gender\" => \"M\",     # Optional; Values: \"M\": Male, \"F\": Female   \"reason\" => \"Remittance payment\",     # Optional; Default value is 'Remittance payment'   \"identity_card_type\" => \"ID\",     # Optional; Values: \"PP\": Passport, \"ID\": National ID   \"identity_card_id\" => 'AB12345678'     # Optional } ```  Please note when sending MAD::Cash payments you should subscribe to the recipient.pending webhook, as that will broadcast the payment reference ID the customer need to use to obtain the funds. Example webhook response excerpt -  ```JSON {   (...)   \"state\":\"pending\",   \"metadata\": {     \"payment_reference\":\"9M5GJRJUBCY\"   },   (...) } ```  The reference can also be provided optionally for MAD::Cash, but if you want to use this functionality please contact us for more details.
class PayoutMethodDetailsMADCash
  attr_accessor :first_name

  attr_accessor :last_name

  attr_accessor :phone_number

  attr_accessor :sender_identity_card_type

  attr_accessor :sender_identity_card_id

  attr_accessor :sender_city_of_birth

  attr_accessor :sender_country_of_birth

  attr_accessor :sender_gender

  attr_accessor :reason

  attr_accessor :identity_card_type

  attr_accessor :identity_card_id

  # Attribute mapping from ruby-style variable name to JSON key.
  def self.attribute_map
    {
      :'first_name' => :'first_name',
      :'last_name' => :'last_name',
      :'phone_number' => :'phone_number',
      :'sender_identity_card_type' => :'sender_identity_card_type',
      :'sender_identity_card_id' => :'sender_identity_card_id',
      :'sender_city_of_birth' => :'sender_city_of_birth',
      :'sender_country_of_birth' => :'sender_country_of_birth',
      :'sender_gender' => :'sender_gender',
      :'reason' => :'reason',
      :'identity_card_type' => :'identity_card_type',
      :'identity_card_id' => :'identity_card_id'
    }
  end

  # Attribute type mapping.
  def self.openapi_types
    {
      :'first_name' => :'String',
      :'last_name' => :'String',
      :'phone_number' => :'String',
      :'sender_identity_card_type' => :'PayoutMethodIdentityCardTypeEnum',
      :'sender_identity_card_id' => :'String',
      :'sender_city_of_birth' => :'String',
      :'sender_country_of_birth' => :'String',
      :'sender_gender' => :'PayoutMethodGenderEnum',
      :'reason' => :'String',
      :'identity_card_type' => :'PayoutMethodIdentityCardTypeEnum',
      :'identity_card_id' => :'String'
    }
  end

  # Initializes the object
  # @param [Hash] attributes Model attributes in the form of hash
  def initialize(attributes = {})
    if (!attributes.is_a?(Hash))
      fail ArgumentError, "The input argument (attributes) must be a hash in `TransferZero::PayoutMethodDetailsMADCash` initialize method"
    end

    # check to see if the attribute exists and convert string to symbol for hash key
    attributes = attributes.each_with_object({}) { |(k, v), h|
      if (!self.class.attribute_map.key?(k.to_sym))
        fail ArgumentError, "`#{k}` is not a valid attribute in `TransferZero::PayoutMethodDetailsMADCash`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
      end
      h[k.to_sym] = v
    }

    if attributes.key?(:'first_name')
      self.first_name = attributes[:'first_name']
    end

    if attributes.key?(:'last_name')
      self.last_name = attributes[:'last_name']
    end

    if attributes.key?(:'phone_number')
      self.phone_number = attributes[:'phone_number']
    end

    if attributes.key?(:'sender_identity_card_type')
      self.sender_identity_card_type = attributes[:'sender_identity_card_type']
    end

    if attributes.key?(:'sender_identity_card_id')
      self.sender_identity_card_id = attributes[:'sender_identity_card_id']
    end

    if attributes.key?(:'sender_city_of_birth')
      self.sender_city_of_birth = attributes[:'sender_city_of_birth']
    end

    if attributes.key?(:'sender_country_of_birth')
      self.sender_country_of_birth = attributes[:'sender_country_of_birth']
    end

    if attributes.key?(:'sender_gender')
      self.sender_gender = attributes[:'sender_gender']
    end

    if attributes.key?(:'reason')
      self.reason = attributes[:'reason']
    end

    if attributes.key?(:'identity_card_type')
      self.identity_card_type = attributes[:'identity_card_type']
    end

    if attributes.key?(:'identity_card_id')
      self.identity_card_id = attributes[:'identity_card_id']
    end
  end

  # Show invalid properties with the reasons. Usually used together with valid?
  # @return Array for valid properties with the reasons
  def list_invalid_properties
    invalid_properties = Array.new
    if @first_name.nil?
      invalid_properties.push('invalid value for "first_name", first_name cannot be nil.')
    end

    if @last_name.nil?
      invalid_properties.push('invalid value for "last_name", last_name cannot be nil.')
    end

    if @phone_number.nil?
      invalid_properties.push('invalid value for "phone_number", phone_number cannot be nil.')
    end

    if @sender_identity_card_type.nil?
      invalid_properties.push('invalid value for "sender_identity_card_type", sender_identity_card_type cannot be nil.')
    end

    if @sender_identity_card_id.nil?
      invalid_properties.push('invalid value for "sender_identity_card_id", sender_identity_card_id cannot be nil.')
    end

    invalid_properties
  end

  # Check to see if the all the properties in the model are valid
  # @return true if the model is valid
  def valid?
    return false if @first_name.nil?
    return false if @last_name.nil?
    return false if @phone_number.nil?
    return false if @sender_identity_card_type.nil?
    return false if @sender_identity_card_id.nil?
    true
  end

  # Checks equality by comparing each attribute.
  # @param [Object] Object to be compared
  def ==(o)
    return true if self.equal?(o)
    self.class == o.class &&
        first_name == o.first_name &&
        last_name == o.last_name &&
        phone_number == o.phone_number &&
        sender_identity_card_type == o.sender_identity_card_type &&
        sender_identity_card_id == o.sender_identity_card_id &&
        sender_city_of_birth == o.sender_city_of_birth &&
        sender_country_of_birth == o.sender_country_of_birth &&
        sender_gender == o.sender_gender &&
        reason == o.reason &&
        identity_card_type == o.identity_card_type &&
        identity_card_id == o.identity_card_id
  end

  # @see the `==` method
  # @param [Object] Object to be compared
  def eql?(o)
    self == o
  end

  # Calculates hash code according to all attributes.
  # @return [Integer] Hash code
  def hash
    [first_name, last_name, phone_number, sender_identity_card_type, sender_identity_card_id, sender_city_of_birth, sender_country_of_birth, sender_gender, reason, identity_card_type, identity_card_id].hash
  end

require 'active_support/core_ext/hash'
require 'active_support/hash_with_indifferent_access.rb'
# Builds the object from hash
# @param [Hash] attributes Model attributes in the form of hash
# @return [Object] Returns the model itself
def build_from_hash(attributes)
  return nil unless attributes.is_a?(Hash)
  self.class.openapi_types.each_pair do |key, type|
    if type =~ /\AArray<(.*)>/i
      # check to ensure the input is an array given that the the attribute
      # is documented as an array but the input is not
      if attributes[self.class.attribute_map[key]].is_a?(Array)
        self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
      end
    elsif !attributes[self.class.attribute_map[key]].nil?
      self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
    end # or else data not found in attributes(hash), not an issue as the data can be optional
  end

  self
end

# Deserializes the data based on type
# @param string type Data type
# @param string value Value to be deserialized
# @return [Object] Deserialized data
def _deserialize(type, value)
  case type.to_sym
  when :DateTime
    DateTime.parse(value)
  when :Date
    Date.parse(value)
  when :String
    value.to_s
  when :Integer
    value.to_i
  when :Float
    value.to_f
  when :Boolean
    if value.to_s =~ /\A(true|t|yes|y|1)\z/i
      true
    else
      false
    end
  when :Object
    # generic object (usually a Hash), return directly
    value
  when /\AArray<(?<inner_type>.+)>\z/
    inner_type = Regexp.last_match[:inner_type]
    value.map { |v| _deserialize(inner_type, v) }
  when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
    k_type = Regexp.last_match[:k_type]
    v_type = Regexp.last_match[:v_type]
    {}.tap do |hash|
      value.each do |k, v|
        hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
      end
    end
  else # model
    temp_model = TransferZero.const_get(type).new
    temp_model.build_from_hash(value)
  end
end

# Returns the string representation of the object
# @return [String] String presentation of the object
def to_s
  to_hash.to_s
end

# to_body is an alias to to_hash (backward compatibility)
# @return [Hash] Returns the object in the form of hash
def to_body
  to_hash
end

# Returns the object in the form of hash
# @return [Hash] Returns the object in the form of hash
def to_hash
  hash = {}
  self.class.attribute_map.each_pair do |attr, param|
    value = self.send(attr)
    next if value.nil?
    hash[param] = _to_hash(value)
  end
  ::ActiveSupport::HashWithIndifferentAccess.new(hash)
end

def [](key)
  to_hash[key]
end

def dig(*args)
  to_hash.dig(*args)
end

# Outputs non-array value in the form of hash
# For object, use to_hash. Otherwise, just return the value
# @param [Object] value Any valid value
# @return [Hash] Returns the value in the form of hash
def _to_hash(value)
  if value.is_a?(Array)
    value.compact.map { |v| _to_hash(v) }
  elsif value.is_a?(Hash)
    {}.tap do |hash|
      value.each { |k, v| hash[k] = _to_hash(v) }
    end
  elsif value.respond_to? :to_hash
    value.to_hash
  else
    value
  end
end

end

end
